'use strict';

var d3 = require('d3'),
    iobio = require('../../src/viz.js');

var trackHeight = 20,
    m = [44, 60, 30+trackHeight, 120],
    w = 960,
    h = 500;

var div = d3.select("body").append("div").attr('class', 'genechart');

var data = [{"chr":"chr17","annotation_source":"HAVANA","feature_type":"transcript","start":41197580,"end":41277346,"score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"PUTATIVE","level":2,"features":[{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41277199","end":"41277346","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41277199","end":"41277202","score":".","strand":"-","phase":"0","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"start_codon","start":"41277200","end":"41277202","score":".","strand":"-","phase":"0","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41215891","end":"41215968","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41215891","end":"41215968","score":".","strand":"-","phase":"2","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41197580","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"UTR","start":"41277203","end":"41277346","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"UTR","start":"41197580","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000586385.1"}],"center":41246583.5},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"transcript","start":41196313,"end":41277468,"score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"KNOWN","level":3,"features":[{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41277294","end":"41277468","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41249261","end":"41249306","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41247863","end":"41247939","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41243452","end":"41246877","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41243452","end":"41246659","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"start_codon","start":"41246657","end":"41246659","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41242961","end":"41243049","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41242961","end":"41243049","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41234421","end":"41234592","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41234421","end":"41234592","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41228505","end":"41228631","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41228505","end":"41228631","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41226348","end":"41226538","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41226348","end":"41226538","score":".","strand":"-","phase":"1","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41222945","end":"41223255","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41222945","end":"41223255","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41219625","end":"41219712","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41219625","end":"41219712","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215891","end":"41215968","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215891","end":"41215968","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41196313","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41277294","end":"41277468","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41249261","end":"41249306","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41247863","end":"41247939","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41246660","end":"41246877","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41196313","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000309486.4"}],"center":41267292},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"transcript","start":41196313,"end":41277468,"score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"KNOWN","level":3,"features":[{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41277294","end":"41277468","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41276034","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"start_codon","start":"41276111","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41267743","end":"41267796","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41267743","end":"41267796","score":".","strand":"-","phase":"1","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41258473","end":"41258550","score":".","strand":"-","phase":"1","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256885","end":"41256973","score":".","strand":"-","phase":"1","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256139","end":"41256278","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41251792","end":"41251897","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41249261","end":"41249306","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41249261","end":"41249306","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41247863","end":"41247939","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41247863","end":"41247939","score":".","strand":"-","phase":"1","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41243452","end":"41246877","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41243452","end":"41246877","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41242961","end":"41243049","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41242961","end":"41243049","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41234421","end":"41234592","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41234421","end":"41234592","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215891","end":"41215968","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215891","end":"41215968","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41196313","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41277294","end":"41277468","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41276114","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41196313","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000346315.3"}],"center":41225194.5},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"transcript","start":41196313,"end":41276132,"score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"KNOWN","level":3,"features":[{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41276034","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"start_codon","start":"41276111","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41267743","end":"41267796","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41267743","end":"41267796","score":".","strand":"-","phase":"1","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41258473","end":"41258550","score":".","strand":"-","phase":"1","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256885","end":"41256973","score":".","strand":"-","phase":"1","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256139","end":"41256278","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41251792","end":"41251897","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41242961","end":"41243049","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41242961","end":"41243049","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41234421","end":"41234592","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41234421","end":"41234592","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41228505","end":"41228631","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41228505","end":"41228631","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41226348","end":"41226538","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41226348","end":"41226538","score":".","strand":"-","phase":"1","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41222945","end":"41223255","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41222945","end":"41223255","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41219625","end":"41219712","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41219625","end":"41219712","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215891","end":"41215968","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215891","end":"41215968","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41196313","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41276114","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41196313","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000351666.3"}],"center":41263146.5},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"transcript","start":41196313,"end":41277500,"score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"KNOWN","level":3,"features":[{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41277288","end":"41277500","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41276034","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"start_codon","start":"41276111","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41267743","end":"41267796","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41267743","end":"41267796","score":".","strand":"-","phase":"1","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41258473","end":"41258550","score":".","strand":"-","phase":"1","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256885","end":"41256973","score":".","strand":"-","phase":"1","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256139","end":"41256278","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41251792","end":"41251897","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41249261","end":"41249306","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41249261","end":"41249306","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41247863","end":"41247939","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41247863","end":"41247939","score":".","strand":"-","phase":"1","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41242961","end":"41243049","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41242961","end":"41243049","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41234421","end":"41234592","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41234421","end":"41234592","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41228505","end":"41228631","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41228505","end":"41228631","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41226348","end":"41226538","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41226348","end":"41226538","score":".","strand":"-","phase":"1","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41222945","end":"41223255","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41222945","end":"41223255","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41219625","end":"41219712","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41219625","end":"41219712","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215891","end":"41215968","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215891","end":"41215968","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41196313","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41277288","end":"41277500","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41276114","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41196313","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000352993.3"}],"center":41263146.5},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"transcript","start":41196313,"end":41277500,"score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"KNOWN","level":3,"features":[{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41277288","end":"41277500","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41276034","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"start_codon","start":"41276111","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41267743","end":"41267796","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41267743","end":"41267796","score":".","strand":"-","phase":"1","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41258473","end":"41258550","score":".","strand":"-","phase":"1","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256885","end":"41256973","score":".","strand":"-","phase":"1","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41256139","end":"41256278","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41251792","end":"41251897","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41249261","end":"41249306","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41249261","end":"41249306","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41247863","end":"41247939","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41247863","end":"41247939","score":".","strand":"-","phase":"1","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41243452","end":"41246877","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41243452","end":"41246877","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41242961","end":"41243049","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41242961","end":"41243049","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41234421","end":"41234592","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41234421","end":"41234592","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"exon","start":"41196313","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41277288","end":"41277500","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41276114","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"},{"chr":"chr17","annotation_source":"ENSEMBL","feature_type":"UTR","start":"41196313","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000354071.3"}],"center":41224905.5},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"transcript","start":41196312,"end":41277387,"score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3","gene_name":"BRCA1","transcript_type":"protein_coding","transcript_status":"KNOWN","level":2,"features":[{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41277288","end":"41277387","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41276034","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41276034","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"start_codon","start":"41276111","end":"41276113","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41267743","end":"41267796","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41267743","end":"41267796","score":".","strand":"-","phase":"1","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41258473","end":"41258550","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41258473","end":"41258550","score":".","strand":"-","phase":"1","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41256885","end":"41256973","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41256885","end":"41256973","score":".","strand":"-","phase":"1","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41256139","end":"41256278","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41256139","end":"41256278","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41251792","end":"41251897","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41251792","end":"41251897","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41249261","end":"41249306","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41249261","end":"41249306","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41247863","end":"41247939","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41247863","end":"41247939","score":".","strand":"-","phase":"1","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41243452","end":"41246877","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41243452","end":"41246877","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41242961","end":"41243049","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41242961","end":"41243049","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41234421","end":"41234592","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41234421","end":"41234592","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41228505","end":"41228631","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41228505","end":"41228631","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41226348","end":"41226538","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41226348","end":"41226538","score":".","strand":"-","phase":"1","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41222945","end":"41223255","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41222945","end":"41223255","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41219625","end":"41219712","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41219625","end":"41219712","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41215891","end":"41215968","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41215891","end":"41215968","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41215350","end":"41215390","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41215350","end":"41215390","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41209069","end":"41209152","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41209069","end":"41209152","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41203080","end":"41203134","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41203080","end":"41203134","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41201138","end":"41201211","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41201138","end":"41201211","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41199660","end":"41199720","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41199660","end":"41199720","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"exon","start":"41196312","end":"41197819","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"CDS","start":"41197698","end":"41197819","score":".","strand":"-","phase":"2","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"stop_codon","start":"41197695","end":"41197697","score":".","strand":"-","phase":"0","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"UTR","start":"41277288","end":"41277387","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"UTR","start":"41276114","end":"41276132","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"},{"chr":"chr17","annotation_source":"HAVANA","feature_type":"UTR","start":"41196312","end":"41197697","score":".","strand":"-","phase":".","transcript_id":"ENST00000357654.3"}],"center":41263146.5}];

var chart = iobio.viz.gene()
    .start(function(d) { return d.start; })
    .end(function(d) { return d.end; })
    .title(function(d) { return d.transcript_id; })
    .height(h)
    .width(w)
    .transitionDuration(0)
    .trackHeight(trackHeight)
    .margin( {top: m[0], right: m[1], bottom: m[2], left:m[3]} );

var selection = div.datum( data );
chart( selection );

describe("gene viz", function() {

    // Even transitions with 0 duration take 17ms
    // So delay all tests for 50 ms so transitions can finish
    beforeAll(function(done) {
        window.setTimeout(function(){done();},50);
    });

    describe("feature", function() {
        var f = d3.selectAll('.cds rect')[0][30];
        it("is being drawn with the right x value", function() {
          expect(parseInt(f.getAttribute('x'))).toEqual(452);
        });

        it("is being drawn with the right y value", function() {
          expect(parseInt(f.getAttribute('y'))).toEqual(0);
        });

        it("is being drawn with the right width", function() {
          expect(parseInt(f.getAttribute('width'))).toEqual(32);
        });

        it("is being drawn with the right height", function() {
          expect(parseInt(f.getAttribute('height'))).toEqual(20);
        });
    })
});